<script setup lang="ts">
  import { Popover, PopoverButton, PopoverPanel, TransitionRoot } from '@headlessui/vue';
  import { emitsKey } from './model';

  const emits = inject(emitsKey);

  const leavePresentationController = useModal();

  const openConfirmModal = (closePopover: () => void) => {
    closePopover();
    leavePresentationController.open();
  };

  const leavePresentation = async () => {
    await emits?.onChange('leavePresentation');
    leavePresentationController.close();
  };
</script>

<template>
  <SwModal :controller="leavePresentationController">
    <template #body>
      <p class="text-information-dark text-lg font-bold">
        {{ $t('presentation.leavePresentation') }}
      </p>
      <p class="text-information mt-2 text-sm">{{ $t('presentation.confirmLeavePresentation') }}</p>
    </template>
    <template #footer>
      <SwButton variant="action" @click="leavePresentationController.close">{{
        $t('cancel')
      }}</SwButton>
      <SwButton @click="leavePresentation">{{ $t('leave') }}</SwButton>
    </template>
  </SwModal>

  <Popover v-slot="{ open, close }" class="relative">
    <PopoverButton as="div">
      <SwTooltip
        :content="$t('presentation.leavePresentation')"
        position="topCenter"
        :disabled="open"
      >
        <SwButton fab variant="danger">
          <template #icon>
            <span class="i-sw-solid:phone rotate-[135deg]"></span>
          </template>
        </SwButton>
      </SwTooltip>
    </PopoverButton>

    <TransitionRoot
      appear
      as="template"
      :show="open"
      enter="transition duration-200 ease-out"
      enter-from="opacity-0"
      enter-to="opacity-100"
      leave="transition duration-150 ease-in"
      leave-from="opacity-100"
      leave-to="opacity-0"
    >
      <PopoverPanel
        class="rounded-2 shadow-5 absolute bottom-16 left-1/2 z-10 flex -translate-x-1/2 gap-2 bg-white p-3"
      >
        <SwButton variant="action" size="medium" @click="close">{{ $t('cancel') }}</SwButton>
        <SwButton variant="danger" size="medium" @click="openConfirmModal(close)">{{
          $t('leave')
        }}</SwButton>
      </PopoverPanel>
    </TransitionRoot>
  </Popover>
</template>
